unit d2doom1;

interface

{
 CopyLeft 1999, By Paul TOTH <tothpaul@multimania.com>
 http://www.multimania.com/tothpaul

 a BP7 version is also available
}

{ from BSP.CPP
//DOOM levels player by Ivaylo Beltchev
//email: ivob@geocities.com
//url:   http://www.geocities.com/SiliconValley/Bay/2234
}


{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DIBS,DATA, ExtCtrls, Spin;

Const
 maxx=640; // change this 2 value to grow resolution
 maxy=400; // (OnCreate will update DIB size)

 midx=maxx div 2;
 midy=maxy div 2;

type
  float=single;

  TForm1 = class(TForm)
    Panel1: TPanel;
    SpinButton1: TSpinButton;
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
  private
    DIB: TDIB256;

    cs,sn:float;
    vxi,vyi:float;
    cols:integer;
    uptr,dptr:array[0..maxx-1] of integer;
    sx,sy:word;
    tx,ty:word;
    Pal:PChar;

    txwall:PWallTexture;
    txptr:PChar;
    txfloor:PFloorTexture;
    txceiling:PFloorTexture;
    txcf:PFloorTexture;
    txxo:integer;
    txyo:integer;

    hceil:longint;
    hfloor:longint;

    snc,csc,snh,csh:float;

    wx,wx1,wy1,wx2,wy2:float;
    a,b,c,dx,dy:float;
    a2,b2:float;
    y1,y2,dy1,dy2:float;
    flags:integer;

    procedure drawdib;
    procedure InitDraw;
    procedure WalkTree(i:integer);
    procedure DrawGun;
    procedure draw1(i:integer);
    procedure drawpoly1(x1,x2:integer;a1,b1:float);
    procedure drawcf(x,y,w:word);
    procedure drawhorc(x,y,w:integer);
    procedure drawhorf(x,y,w:integer);
    procedure drawwall(x,y,dh:integer;step,beg:word);
    procedure draw2(i:integer);
    procedure drawpoly2(x1,x2:integer);
  public
    { Dclarations publiques }
    start:boolean;
    startx:integer;
    starty:integer;
    starta:integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Const
 prec=256;
 foc=midx;

 xmin=-midx;
 xmax=+midx;
 ymin=-midy;
 ymax=+midy;

 flDFLOOR= 1;
 flDCEIL = 2;
 flDWALL = 4;
 flMFLOOR= 8;
 flMCEIL =16;

procedure TForm1.FormPaint(Sender: TObject);
begin
 DIB.DrawXY(Canvas.Handle,(ClientWidth-DIB.Width) div 2,Panel1.Height+(ClientHeight-Panel1.Height-DIB.Height) div 2);
// DIB.StretchDraw(Canvas.Handle,ClientWidth,ClientHeight);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 x:integer;
begin
 // load bsp in DATA.PAS
 DIB:=TDIB256.Create(Self);
 DIB.Width:=maxx;
 DIB.Height:=maxy;
 for x:=0 to 255 do begin
  DIB.Color[x]:=RGB(Palette[x,0] shl 2,Palette[x,1] shl 2,Palette[x,2] shl 2);
 end;
 DIB.UpdateColors;
 drawdib;
end;

procedure TForm1.Drawdib;
begin
 InitDraw;
 walktree(0);
 DrawGun;
end;

procedure TForm1.InitDraw;
 var
  x:integer;
 begin
  cs:=cos(playera*2*PI/128);
  sn:=sin(playera*2*PI/128);
  vxi:=playerx*prec;
  vyi:=playery*prec;
 { all columns available }
  cols:=maxx;
  for x:=0 to maxx-1 do begin
   uptr[x]:=0;
   dptr[x]:=maxy;
  end;
 end;

procedure TForm1.WalkTree(i:integer);
 begin
  if cols=0 then exit;
  with walls^[i] do begin
  { infront }
   if (y1-y2)*(x1-playerx)>(x1-x2)*(y1-playery) then begin
    if RightWall>0 then begin
     WalkTree(RightWall);
     if cols=0 then exit;
    end;
    draw1(i);
    if LeftWall>0 then WalkTree(LeftWall);
   end else begin
    if LeftWall>0 then begin
     WalkTree(LeftWall);
     if cols=0 then exit;
    end;
    draw2(i);
    if RightWall>0 then WalkTree(RightWall);
   end;
  end;
 end;

procedure TForm1.DrawGun;
 var
  x,y:integer;
  gx,gy:integer;
  c:byte;
 begin
  gx:=midx-gunx div 2;
  gy:=maxy-guny;
  for y:=0 to guny-1 do begin
   for x:=0 to gunx-1 do begin
    c:=gunbmp[x,y];
    if c<255 then DIB.SetPixel(gx+x,gy,c);
   end;
   inc(gy);
  end;
 end;

procedure TForm1.draw1(i:integer);
 var
  x1,x2:float;
  h1,h2:longint;
  a1,b1:float;
 begin
 { origine }
  wx1:=walls^[i].x1-playerx;
  wy1:=walls^[i].y1-playery;
  wx2:=walls^[i].x2-playerx;
  wy2:=walls^[i].y2-playery;

 { rotate wall }
  wx :=wx1*cs-wy1*sn;
  wy1:=wx1*sn+wy1*cs;
  wx1:=wx;
  wx :=wx2*cs-wy2*sn;
  wy2:=wx2*sn+wy2*cs;
  wx2:=wx;

  if (wy1<0) and (wy2<0) then exit; { unvisible }

  b:=wx1*wy2-wx2*wy1;
  if (b=0) then exit;

  dy:=wy2-wy1;
  dx:=wx2-wx1;

 { project + X clipping }
  if (wy1>0) then begin
   x1:=(wx1*foc/wy1);
   if (x1<xmin) then x1:=xmin;
  end else
   x1:=xmin;

  if (wy2>0) then begin
   x2:=(wx2*foc/wy2);
   if (x2>xmax) then x2:=xmax;
  end else
   x2:=xmax;

  if (x1>=x2) then exit; { wrong face }

  flags:=flDFLOOR or flMFLOOR;

  if (walls^[i].h2=walls^[i].h3) then flags:=flags or flDCEIL or flMCEIL;
  if (flags and flDCEIL)<>0 then h1:=walls^[i].h4 else h1:=walls^[i].h2;
  dec(h1,playerz);
  h2:=walls^[i].h1-playerz;

   a:= h1*dy;
   c:=-h1*dx;

   y1:=(a*x1+c*foc)/b;
  dy1:=a/b;

   a:= h2*dy;
   c:=-h2*dx;

   y2:=(a*x1+c*foc)/b;
  dy2:=a/b;

  txwall:=WallTextures[walls^[i].Texture];
  txfloor:=FloorTextures[walls^[i].FrontFloor];
  txceiling:=FloorTextures[walls^[i].FrontCeiling];
  txxo:=walls^[i].TextureX;
  txyo:=walls^[i].TextureY;

  hceil:=walls^[i].h4-playerz;
  hfloor:=playerz-walls^[i].h1;

  snc:= hceil*prec*sn;
  csc:= hceil*prec*cs;
  snh:=hfloor*prec*sn;
  csh:=hfloor*prec*cs;

  a1:= Walls^[i].length*(foc*wx1-x1*wy1);
  b1:= x1*dy-foc*dx;

  a2:=-Walls^[i].length*wy1;
  b2:= dy;

  drawpoly1(round(x1),round(x2),a1,b1);

  if (flags and flDCEIL)<>0 then exit;

  h1:=Walls^[i].h4-playerz;
  h2:=Walls^[i].h3-playerz;

  if (b<>0) then begin
     a:= h1*dy;
     c:=-h1*dx;
    y1:=(a*x1+c*foc)/b;
   dy1:= a/b;
     a:= h2*dy;
     c:=-h2*dx;
    y2:=(a*x1+c*foc)/b;
   dy2:= a/b;
  end else begin
   if h1<0 then y1:=ymin else y1:=ymax;
   dy1:=0;
   if h2<0 then y2:=ymin else y2:=ymax;
   dy2:=0;
  end;

  flags:=flDCEIL or flMCEIL;

  drawpoly1(round(x1),round(x2),a1,b1);
 end;

procedure TForm1.drawpoly1(x1,x2:integer;a1,b1:float);
 var
  t,step,beg:word;
  cptr,fptr:array[0..maxy-1] of integer;
  fu1,fd1,fu,fd:longint;
  cu1,cd1,cu,cd:longint;
  shade:integer;
  stepd:float;

  x,y:integer;
  h1,h2:integer;
 begin
 { center x }
  inc(x1,midx);
  inc(x2,midx);

 { center y (with look up/down) }
  y1:=midy-y1+playerv;
  y2:=midy-y2+playerv;

  cd1:=uptr[x1]; cu1:=cd1;
  fd1:=dptr[x1]; fu1:=fd1;

 { from left to right }
  for x:=x1 to (x2-1) do begin

    if uptr[x]>=dptr[x] then begin

      if (flags and flDCEIL)>0 then begin
        for y:=cu1 to cd1-1 do
          if (x-cptr[y]>0) then drawhorc(cptr[y],y,x-cptr[y]);
        cu1:=cd1;
      end;

      if (flags and flDFLOOR)>0 then begin
        for y:=fu1 to fd1-1 do
          if (x-fptr[y]>0) then drawhorf(fptr[y],y,x-fptr[y]);
        fu1:=fd1;
      end;

    end else begin

     h1:=round(y1);
     h2:=round(y2);

    { h clipping }
     if (h1<uptr[x]) then h1:=uptr[x];
     if (h2>dptr[x]) then h2:=dptr[x];

     if (flags and flDCEIL)>0 then begin
      if (h1>dptr[x]) then h1:=dptr[x];
      cu:=uptr[x];
      cd:=h1;
      for y:=cu to cu1-1 do cptr[y]:=x;
      for y:=cd1 to cd-1 do cptr[y]:=x;
      for y:=cu1 to cu-1 do
       if (x-cptr[y]>0) then drawhorc(cptr[y],y,x-cptr[y]);
      for y:=cd to cd1-1 do
        if (x-cptr[y]>0) then drawhorc(cptr[y],y,x-cptr[y]);
      cu1:=cu;
      cd1:=cd;
     end;

     if (flags and flDFLOOR)>0 then begin
      if (h2<uptr[x]) then h2:=uptr[x];
      fu:=h2;
      fd:=dptr[x];
      for y:=fu to fu1-1 do fptr[y]:=x;
      for y:=fd1 to fd-1 do fptr[y]:=x;
      for y:=fu1 to fu-1 do
       if (x-fptr[y]>0) then drawhorf(fptr[y],y,x-fptr[y]);
      for y:=fd to fd1-1 do
       if (x-fptr[y]>0) then drawhorf(fptr[y],y,x-fptr[y]);
      fu1:=fu;
      fd1:=fd;
     end;

     if ((flags and flMCEIL )>0) and (h2>uptr[x]) then uptr[x]:=h2;
     if ((flags and flMFLOOR)>0) and (h1<dptr[x]) then dptr[x]:=h1;

    { done with this column ? }
     if (uptr[x]>=dptr[x]) then dec(cols);

    { draw the wall ? }
     if (h2-h1>0) then begin
      stepd:=b/b1;

      shade:=round(512/stepd);
      if (shade<0) then shade:=0;
      if (shade>254) then shade:=254;
      Pal:=@PalTbl^[shade];

      step:=round(stepd*256);
      beg:=(h1-midy-playerv)*step-(txyo+playerz)*256;

      t:=round(a1/b1)+txxo;
      txptr:=@txwall^[t and 127];

      drawwall(x,h1,h2-h1,step,beg);
     end;

    end;
   { Next Texture pixel }
    a1:=a1+a2;
    b1:=b1+b2;
   { Adjust Height }
    y1:=y1-dy1;
    y2:=y2-dy2;
  end;

  if (flags and flDCEIL)>0 then
    for y:=cu1 to cd1-1 do
      if (x2-cptr[y]>0) then drawhorc(cptr[y],y,x2-cptr[y]);

  if (flags and flDFLOOR)>0 then
    for y:=fu1 to fd1-1 do
     if (x2-fptr[y]>0) then drawhorf(fptr[y],y,x2-fptr[y]);


 end;

procedure TForm1.drawcf(x,y,w:word);
 var
  i:integer;
 begin
  for i:=1 to w do begin
   DIB.SetPixel(x,y,ord(Pal[txcf^[hi(ty) and 63,hi(tx) and 63]]));
   inc(x);
   inc(tx,sx);
   dec(ty,sy);
  end;
 end;

procedure TForm1.drawhorc(x,y,w:integer);
 var
  yy:integer;
  shade:integer;
 begin
  yy:=midy-y+playerv;
  if (yy<>0) then begin
   sx:=round(csc/yy) and $3FFF;
   sy:=round(snc/yy) and $3FFF;
   tx:=round(vxi+foc*sy+(x-midx)*sx) and $3FFF;
   ty:=round(vyi+foc*sx-(x-midx)*sy) and $3FFF;
  end else begin
   sx:=0;
   sy:=0;
   tx:=round(vxi) and $3FFF;
   ty:=round(vyi) and $3FFF;
  end;

  if (hceil>0) then begin
   shade:=round(512*(yy/hceil)) and $FFF;
   if (shade<0) then shade:=0;
   if (shade>254) then shade:=254;
  end else
   shade:=254;
  Pal:=@PalTbl^[Shade];

  txcf:=txceiling;
  drawcf(x,y,w);
 end;

procedure Tform1.drawhorf(x,y,w:integer);
 var
  yy:integer;
  shade:integer;
 begin
  yy:=y-midy-playerv;
  if (yy<>0) then begin
   sx:=round(csh/yy);
   sy:=round(snh/yy);
   tx:=round(vxi+foc*sy+(x-midx)*sx);
   ty:=round(vyi+foc*sx-(x-midx)*sy);
  end else begin
   sx:=0;
   sy:=0;
   tx:=round(vxi);
   ty:=round(vyi);
  end;

  if (hfloor<>0) then begin
   shade:=round(512*(yy/hfloor));
   if (shade<0) then shade:=0;
   if (shade>254) then shade:=254;
  end else
   shade:=254;
  Pal:=@PalTbl^[Shade];

  txcf:=txfloor;

  drawcf(x,y,w);
 end;

procedure TForm1.drawwall(x,y,dh:integer;step,beg:word);
 var
  i:integer;
 begin
  for i:=0 to dh do begin
   DIB.SetPixel(x,y,ord(Pal[ord(txptr[hi(beg) and 127])]));
   inc(y);
   inc(beg,step);
  end;
 end;

procedure Tform1.draw2(i:integer);
 var
  x1,x2:float;
  h1,h2:longint;
 begin

  if (walls^[i].h2=walls^[i].h3) then exit;

  wx1:=walls^[i].x2-playerx;
  wy1:=walls^[i].y2-playery;
  wx2:=walls^[i].x1-playerx;
  wy2:=walls^[i].y1-playery;

  wx :=wx1*cs-wy1*sn;
  wy1:=wx1*sn+wy1*cs;
  wx1:=wx;
  wx :=wx2*cs-wy2*sn;
  wy2:=wx2*sn+wy2*cs;
  wx2:=wx;

  if (wy1<0) and (wy2<0) then exit;

  b:=wx1*wy2-wx2*wy1;
  if (b=0) then exit;

  dy:=wy2-wy1;
  dx:=wx2-wx1;

  if (wy1>0) then begin
   x1:=(wx1*foc/wy1);
   if (x1<xmin) then x1:=xmin;
  end else
   x1:=xmin;

  if (wy2>0) then begin
   x2:=(wx2*foc/wy2);
   if (x2>xmax) then x2:=xmax;
  end else
   x2:=xmax;

  if (x1>=x2) then exit;

  h1:=walls^[i].h3-playerz;
  h2:=walls^[i].h2-playerz;

    a:= h1*dy;
    c:=-h1*dx;
   y1:=(a*x1+c*foc)/b;
  dy1:=a/b;

    a:= h2*dy;
    c:=-h2*dx;
   y2:=(a*x1+c*foc)/b;
  dy2:=a/b;

  txfloor:=FloorTextures[walls^[i].BackFloor];
  txceiling:=FloorTextures[walls^[i].BackCeiling];

  hceil:=walls^[i].h3-playerz;
  hfloor:=playerz-walls^[i].h2;

  snc:= hceil*prec*sn;
  csc:= hceil*prec*cs;
  snh:=hfloor*prec*sn;
  csh:=hfloor*prec*cs;

  flags:=flDFLOOR or flMFLOOR or flDCEIL or flMCEIL;

  drawpoly2(round(x1),round(x2));
 end;

procedure TForm1.drawpoly2(x1,x2:integer);
 var
  y:integer;
  lptr:array[0..maxy-1] of integer;
  fu1,fd1,fu,fd:integer;
  cu1,cd1,cu,cd:integer;
  x,h1,h2:integer;
 begin
  inc(x1,midx);
  inc(x2,midx);
  y1:=midy-y1+playerv;
  y2:=midy-y2+playerv;

  cu1:=uptr[x1]; cd1:=cu1;
  fu1:=dptr[x1]; fd1:=fu1;

  for x:=x1 to x2-1 do begin

   if (uptr[x]>=dptr[x]) then begin

    if (flags and flDCEIL)>0 then begin
     for y:=cu1 to cd1-1 do if (x-lptr[y]>0) then drawhorc(lptr[y],y,x-lptr[y]);
     cu1:=cd1;
    end;
    if (flags and flDFLOOR)>0 then begin
     for y:=fu1 to fd1-1 do if (x-lptr[y]>0) then drawhorf(lptr[y],y,x-lptr[y]);
     fu1:=fd1;
    end;

   end else begin { goto cont }

    h1:=round(y1);
    h2:=round(y2);

    if (h1<uptr[x]) then h1:=uptr[x];
    if (h2>dptr[x]) then h2:=dptr[x];

    if (flags and flDCEIL)>0 then begin
     if (h1>dptr[x]) then h1:=dptr[x];
     cu:=uptr[x];
     cd:=h1;
     for y:=cu to cu1-1 do lptr[y]:=x;
     for y:=cd1 to cd-1 do lptr[y]:=x;
     for y:=cu1 to cu-1 do if (x-lptr[y]>0) then drawhorc(lptr[y],y,x-lptr[y]);
     for y:=cd to cd1-1 do if (x-lptr[y]>0) then drawhorc(lptr[y],y,x-lptr[y]);
     cu1:=cu;
     cd1:=cd;
    end;

    if (flags and flDFLOOR)>0 then begin
     if (h2<uptr[x]) then h2:=uptr[x];
     fu:=h2;
     fd:=dptr[x];
     for y:=fu to fu1-1 do lptr[y]:=x;
     for y:=fd1 to fd-1 do lptr[y]:=x;
     for y:=fu1 to fu-1 do if (x-lptr[y]>0) then drawhorf(lptr[y],y,x-lptr[y]);
     for y:=fd to fd1-1 do if (x-lptr[y]>0) then drawhorf(lptr[y],y,x-lptr[y]);
     fu1:=fu;
     fd1:=fd;
    end;

    if ((flags and flMCEIL)>0) and (h1>uptr[x]) then uptr[x]:=h1;
    if ((flags and flMFLOOR)>0) and (h2<dptr[x]) then dptr[x]:=h2;

   end; { cont }

   y1:=y1-dy1;
   y2:=y2-dy2;

  end;

  if (flags and flDCEIL)>0 then
    for y:=cu1 to cd1-1 do
      if (x2-lptr[y]>0) then drawhorc(lptr[y],y,x2-lptr[y]);

  if (flags and flDFLOOR)>0 then
    for y:=fu1 to fd1-1 do
      if (x2-lptr[y]>0) then drawhorf(lptr[y],y,x2-lptr[y]);
 end;

procedure TForm1.FormResize(Sender: TObject);
begin
 invalidate;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 start:=true;
 startx:=x;
 starty:=y;
 starta:=PlayerA;
 screen.cursor:=crsize;
 if Button=mbLeft then begin
  PlayerV:=0;
  repeat
   Inc(PlayerX,Round((2*ClientHeight div 3-starty)*sn));
   Inc(PlayerY,Round((2*ClientHeight div 3-starty)*cs));
   inc(PlayerA,(startx-ClientWidth div 2) div 10);
   drawdib;
   onpaint(self);
   application.processmessages;
  until start=false;
 end else begin
  repeat
   PlayerV:=(ClientHeight div 2-starty);
   //inc(PlayerA,(startx-ClientWidth div 2) div 10);
   PlayerA:=starta-255*(ClientWidth div 2-startx) div ClientWidth;
   drawdib;
   onpaint(self);
   application.processmessages;
  until start=false;
 end;
 screen.cursor:=crdefault;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 start:=false;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 startx:=x;
 starty:=y;
end;

procedure TForm1.SpinButton1DownClick(Sender: TObject);
begin
 dec(playerz,10);
 drawdib;
 onpaint(self);
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
begin
 inc(playerz,10);
 drawdib;
 onpaint(self);
end;

end.
